
    'this is version 2.5 issued 8th Feb 2021
    'reverse button implemented, since its actioned on humans move computer plays their move.
    'v2.1 playermove load game fixed to make white play first on new black game
    'v2.2 actioncomputermove fixed to try temporary move and incheck() rather than actual pointless move
    'v2.3 reversible white/black play added
    'v2.4 reverse button implemented, since its reversed on humans move computer plays their move.
    'v2.5 new data format SNXVVVV SNX=sprite S=sign W/B N= name RNBQKP X=1-8 VVVV=value example "WR1 500"
    'New data format reduces array swapping to give four fold speed increase.
    'On an open board with many moves possible AI can be assessing up to 20k moves!

     nomainwin
    'Based on How To Write A Chess Programm in QBASIC By Dean Menezes.
    'http://www.petesqbsite.com/sections/express/issue23/Tut_QB_Chess.txt
    'graphics originate under Creative commons attribution license but have been largely redrawn.
    'https://all-free-download.com/free-vector/download/chess-design-elements-vector-set_571689.html
    'ported to Liberty BASIC by rodbird@hotmail.com
    'bug fixes with the help of tsh73,B+

    'To play LOAD the game of your choice, White,Black Saved. The default starting game is White.
    'White has the first move so human first. If you load a Black game the computer plays White and will
    'take the first move. Always click on the square on the board not on the piece. Click on the square
    'you want to move from, then the square you want to move to. Normal rules of chess apply.

    'While the computer is thinking the game will become unresponsive, you can only make selections
    'during your turn.

    'You may PAUSE the current game, SAVE it for later play, LOAD it or a new game. UNDO takes the game
    'back to before your last move and lets you replay it. Reverse swaps the board and the AI will play
    'the players color from then on.

    'In Liberty BASIC arrays are Global. In QBasic arrays are not and can be passsed
    'to functions and subs. The program made extensive use of passed arrays
    'to mimic that I used the Level variable to add another dimension
    'to our arrays so that the recursion had somewhere unique to store its values

    'I probably still don't understand the recursive part. No wait. I do understand the
    'recursive code, what I dont understand is how it creates such a powerful
    'chess AI. Qudos to Mr Menezes.

    'the next board parameters never change during play they
    'define the physical dimensions of the game board image
    dim bspritex(7,7) 'x pos to draw sprite on square
    dim bspritey(7,7) 'y pos to draw sprite on square
    dim bspritez(7,7) '% size of sprite on square
    dim bpointrx(8,8) 'x limit for mouse click
    dim bpointry(8,8) 'y limit for mouse click

    'the name of the square changes depending on playing white or black
    dim bsquare$(7,7)

    'now we set up board parameters that move with the player
    dim board$(7,7) 'sprite name currently occupying the square

    'arrays to hold the legal moves a particular piece can make
    dim movex(30,5)    'list of possible x moves for each Level
    dim movey(30,5)    'list of possible y moves for each Level

    'arrays to store the best move for each recursion level
    dim bestx(5)
    dim besty(5)
    dim bestx1(5)
    dim besty1(5)

    'text display mini help
    dim text$(40)
    text$(2)="To play click the"
    text$(3)="square you want"
    text$(4)="to move from then"
    text$(5)="the square to"
    text$(6)="move to."
    text$(7)=""
    text$(8)="Default is white"
    text$(9)="but LOAD a black"
    text$(10)="or saved game."
    text$(11)=""
    text$(12)="You can PAUSE,"
    text$(13)="SAVE, LOAD games."
    text$(14)=""
    text$(15)="You can UNDO your"
    text$(16)="last move."
    text$(17)=""
    text$(18)="Clocks are just"
    text$(19)="for fun."
    text$(20)=""
    text$(21)="Gameplay logged"
    text$(22)="above."


    'global variables
    global AI,Timecounter,Secday,Status,Pause,Move,Level,Maxlevel,Score,Whitetime,Blacktime,White,Black,Spritetaken$,Spriteadded$
    Timecounter=0   'keeps track elapsed time
    Secday=60*60*24 'gets timer through midnight
    Pause=0         'game paused=1 playing=0
    Move=-1         'the number of valid moves found for chosen piece
    Level=0         'recursion level for evaluate()
    Maxlevel=3      'max recursive calls for evaluate() 3 takes a reasonable time, higher will not necessarily play smarter
    Score=0         'worth of play
    Whitetime=0     'clock for white
    Blacktime=0     'clock for black
    White=1         'white constant
    Black=-1        'black constant
    Spritetaken$="" 'list of taken sprites
    Spriteadded$="" 'list of promoted pawns
    AI=Black        'the color played by the computer


    'set out a normal white game and show the board
    call fillboard
    call showboard

    'start tracking the mouse pointer to highlight buttons
    #w.g "when mouseMove trackit"
    Status=-1 'starting

    'main program loop
    do
        if Status=-1 and AI=White then [computer]

        [player]
        Status=1
        call playermove
        call showboard

        [computer]
        Status=2
        if AI=Black then t$="Black to move " else t$="White to move "
        call text t$
        count(1)=0
        result=evaluatecomputermove(AI,10000*(0-AI))
        playwave "play.wav",async
        call actioncomputermove result
        call showboard


    loop while 1
    'end of main program loop




sub actioncomputermove result

    'the results of evaluate are held in best()
    x=bestx(1)
    y=besty(1)
    x1=bestx1(1)
    y1=besty1(1)

    'remove highlights of human players last move
    #w.g "spritevisible m off"
    if board$(old(1),old(2))<>"      0" then #w.g "spriteimage ";left$(board$(old(1),old(2)),3);" ";left$(board$(old(1),old(2)),2)

    'action computer move, take opponent, remove opponent, promote if at edge of board

    'the computer will always return a move even if it is pointless
    'so we need to see if the move avoids check
    'store mover and target data so that it may be restored
    moversprite$=board$(x,y)
    targetsprite$=board$(x1,y1)


    'fill square taken
    board$(x1,y1)=board$(x,y)

    'erase square vacated
    board$(x,y)="      0"


    'now see if we are still in check and so checkmate
    checkmate=incheck(AI)

    'reset play
    board$(x,y)=moversprite$
    board$(x1,y1)=targetsprite$

    if checkmate then
        if AI=Black then t$="Black resigns " else t$="White resigns "
        call text ""
        call text "Checkmate!"
        call text t$
        call text "Game ends"
        wait
    else
        if AI=Black then t$="Black moves " else t$="White moves "
        call text t$;mid$(board$(x,y),2,1);bsquare$(x,y);"-";mid$(board$(x1,y1),2,1);bsquare$(x1,y1)
        if board$(x1,y1)<>"      0" then
            taken=showtaken(x1,y1,AI)
            #w.g "spritevisible ";left$(board$(x1,y1),3);" off"
            Spritetaken$=Spritetaken$+left$(board$(x1,y1),3)+","
        end if
        call makemove x,y,x1,y1
    end if

    'add highlights of computers last move
    if board$(x1,y1)<>"      0" then #w.g "spriteimage ";left$(board$(x1,y1),3);" ";left$(board$(x1,y1),2);"1"
    #w.g "spritexy t ";bspritex(x,y);" ";bspritey(x,y)
    #w.g "spritescale t ";bspritez(x,y)
    #w.g "spritetoback t"
    #w.g "spritevisible t on"
    old(3)=x1
    old(4)=y1

    'did we put the opposition in check?
    if AI=Black then t$="White in check " else t$="Black in check"
    if incheck(0-AI) then call text t$
    call showboard
end sub

sub playermove
    'get and validate players move ie x y to x1 y1

    'save the previous position and store the current position
    kill "undo1.und"
    name "undo.und" as "undo1.und"
    call savegame "undo.und"


    'skip past error routine
    goto [in]

    'come back here if there was an error on input
    [err]
    if board$(x,y)<>"      0" then #w.g "spriteimage ";left$(board$(x,y),3);" ";left$(board$(x,y),2)
    if board$(x1,y1)<>"      0" then #w.g "spriteimage ";left$(board$(x1,y1),3);" ";left$(board$(x1,y1),2)
    #w.g "spritevisible m off"
    #w.g "spritevisible t off"
    #w.g "drawsprites"
    playwave "error.wav",async

    [in]
    'get input and do basic validation of that input
    if AI=Black then t$="White to move " else t$="Black to move "
    call text t$

    'start event tracking
    #w.g "when leftButtonUp [playermove]"
    #w.g "setfocus"

    [timerloop]
    'must use loop and scan, timer statement crashes out
    scan
    if Paused=0 and date$("days")*Secday+time$("seconds")>Timecounter then
        Timecounter=date$("days")*Secday+time$("seconds")
        call clock
    end if
    goto [timerloop]


    [playermove]
    'remove highlights of last move
    if board$(old(3),old(4))<>"      0" then #w.g "spriteimage ";left$(board$(old(3),old(4)),3);" ";left$(board$(old(3),old(4)),2)
    #w.g "spritevisible t off"
    xx=MouseX
    yy=MouseY
    found=0

    'player clicked pause button
    if xx>5 and xx<105 and yy>5 and yy<30 then
        playwave "click.wav",async
        if Paused=1 then
            Paused=0
            call text "Game restarted"
            #w.g "spritevisible po off"
        else
            Paused=1
            call text "Game paused"
            #w.g "spritevisible po on"
        end if
    end if
    'if paused go no further
    if Paused then goto [timerloop]

    'player clicked load game
    if xx>5 and xx<105 and yy>35 and yy<60 then
        playwave "click.wav",async
        filedialog "Open Chess Game ", "*.gam", f$
        if f$<>"" then  call loadgame f$
        call showboard
        call text "Game loaded"
        if instr(f$,"NewBlack.gam",1) then  Status=2 : exit sub
        if AI=Black then t$="White to move " else t$="Black to move "
        call text t$
    end if

    'player clicked save game
    if xx>5 and xx<105 and yy>65 and yy<90 then
        playwave "click.wav",async
        call savegame "saved.gam"
        call text "Game saved"
    end if

    'player clicked undo
    if xx>5 and xx<105 and yy>95 and yy<120 then
        call loadgame "undo1.und"
        call showboard
        call text "Undo"
        if AI=Black then t$="White to move " else t$="Black to move "
        call text t$
    end if

    'player clicked reverse
    if xx>5 and xx<105 and yy>215 and yy<240 then
        call reversegame
        call savegame "undo.und"
        call text "Game reversed"
        Status=2
        exit sub
    end if

    'player clicked resign button
    if xx>5 and xx<105 and yy>185 and yy<210 then
        playwave "click.wav",async
        if AI=Black then t$="White resigns" else t$="Black resigns "
        call text t$
        call text "Game ends"
        Paused=1
        goto [timerloop]
    end if

    'player clicked castle left
    if xx>5 and xx<105 and yy>125 and yy<150 then
        playwave "click.wav",async
        if AI=White then
            'player is black
            if mid$(board$(0,7),2,1)="R" and mid$(board$(3,7),2,1)="K" and mid$(board$(1,7),2,1)=" " and mid$(board$(2,7),2,1)=" " and incheck(-1)=0 then
                call makemove 3,7,1,7
                call makemove 0,7,2,7
                call text "Castles"
                #w.g "drawsprites"
                exit sub
            else
                call text "Illegal move"
                goto [err]
            end if
        else
            'player is white
            if mid$(board$(0,7),2,1)="R" and mid$(board$(4,7),2,1)="K" and mid$(board$(1,7),2,1)=" " and mid$(board$(2,7),2,1)=" " and mid$(board$(3,7),2,1)=" " and incheck(1)=0 then
                call makemove 4,7,2,7
                call makemove 0,7,3,7
                call text "Castles"
                #w.g "drawsprites"
                exit sub
            else
                call text "Illegal move"
                goto [err]
            end if
        end if
    end if

    'player clicked castle right
    if xx>5 and xx<105 and yy>155 and yy<180 then
        playwave "click.wav",async
        if AI=White then
            'player is black
            if mid$(board$(7,7),2,1)="R" and mid$(board$(3,7),2,1)="K" and mid$(board$(4,7),2,1)=" " and mid$(board$(5,7),2,1)=" " and mid$(board$(6,7),2,1)=" " and incheck(-1)=0 then
                call makemove 3,7,5,7
                call makemove 7,7,4,7
                call text "Castles"
                #w.g "drawsprites"
                exit sub
            else
                call text "Illegal move"
                goto [err]
            end if
        else
            'player is white
            if mid$(board$(7,7),2,1)="R" and mid$(board$(4,7),2,1)="K" and mid$(board$(5,7),2,1)=" " and mid$(board$(6,7),2,1)=" " and incheck(1)=0 then
                call makemove 4,7,6,7
                call makemove 7,7,5,7
                call text "Castles"
                #w.g "drawsprites"
                exit sub
            else
                call text "Illegal move"
                goto [err]
            end if
        end if
    end if

    'highlight players first click on selected piece
    if yy>=170 and yy<=516 then
        for y=0 to 7
            for x=0 to 7
                if yy>bpointry(x,y) and yy<bpointry(x,y+1) and xx>bpointrx(x,y) and xx<bpointrx(x+1,y) then
                    if board$(x,y)<>"      0" then #w.g "spriteimage ";left$(board$(x,y),3);" ";left$(board$(x,y),2);"1"
                    #w.g "spritexy m ";bspritex(x,y);" ";bspritey(x,y)
                    #w.g "spritescale m ";bspritez(x,y)
                    #w.g "spritetoback m"
                    #w.g "spritevisible m on"
                    #w.g "drawsprites"
                    px=x
                    py=y
                    found=1
                    exit for
                end if
            next
            if found then exit for
        next
        if found then #w.g "when leftButtonUp [targetsquare]"
    end if
    goto [timerloop]

    [targetsquare]
    xx=MouseX
    yy=MouseY
    found=0
    if yy>=170 and yy<=516 then
        for y=0 to 7
            for x=0 to 7
                if yy>bpointry(x,y) and yy<bpointry(x,y+1) and xx>bpointrx(x,y) and xx<bpointrx(x+1,y) then
                    if x=px and y=py then
                        if board$(x,y)<>"      0" then #w.g "spriteimage ";left$(board$(x,y),3);" ";left$(board$(x,y),2)
                        #w.g "spritevisible m off"
                        #w.g "drawsprites"
                        px=-1
                        py=-1
                        found=0
                        exit for
                    else
                        if board$(x,y)<>"      0" then #w.g "spriteimage ";left$(board$(x,y),3);" ";left$(board$(x,y),2);"1"
                        old(1)=x
                        old(2)=y
                        #w.g "drawsprites"
                        px1=x
                        py1=y
                        found=1
                        exit for
                    end if
                end if
            next
            if found then exit for
        next
        if found then
            #w.g "when leftButtonUp"
        else
            #w.g "when leftButtonUp [playermove]"
            goto [timerloop]
        end if

    end if

    'this is the players choice of move
    x=px
    y=py
    x1=px1
    y1=py1

    [movit]
    'are we on the board and moving correctly colored piece
    if AI=Black then t$="White moves " else t$="Black moves "
    call text t$;mid$(board$(x,y),2,1);bsquare$(x,y);"-";mid$(board$(x1,y1),2,1);bsquare$(x1,y1)
        if x<0 or x>7 or y<0 or y>7 or x1<0 or x1>7 or y1<0 or y1>7 or bsign(x,y)<>0-AI then
        call text "Off board/wrong color "
        goto [err]
    end if


    'validate move is legal for piece
    'and that it does not put us in check
    illegal=1
    call movelist x,y,0-AI
    for m=0 to Move
        if x1=movex(m,Level) and y1=movey(m,Level) then
            illegal=0
            taken=showtaken(x1,y1,0-AI)
            'store mover and target data so that it may be restored
            moversprite$=board$(x,y)
            targetsprite$=board$(x1,y1)
            call makemove x,y,x1,y1
            check=incheck(0-AI)
            if check then
                'reset play
                illegal=1
                call text "You are in check!"
                board$(x,y)=moversprite$
                board$(x1,y1)=targetsprite$
            end if
            exit for
        end if
    next
    if illegal then
        call text "Illegal move"
        goto [err]
    end if

    'finaly we have a legal move
    'did it take a man
    if taken then
        #w.g "spritevisible ";left$(targetsprite$,3);" off"
        Spritetaken$=Spritetaken$+left$(targetsprite$,3)+","
    end if
    'did it check?
     if AI=Black then t$="Black is in check " else t$="White is in check "
    if incheck(AI) then call text t$
    #w.g "drawsprites"
    playwave "play.wav",async
end sub


'get a list of valid moves for a particular piece
'sgn indicates white or black dop indicates direction of play
sub movelist x,y,sgn
    Move=-1 'no move found
    if sgn=White and AI=White then dop=-1
    if sgn=White and AI=Black then dop=1
    if sgn=Black and AI=Black then dop=-1
    if sgn=Black and AI=White then dop=1

    select case mid$(board$(x,y),2,1)
        case "P"
            call pawn x,y,sgn,dop
        case "N"
            call knight x,y,sgn,dop
        case "B"
            call bishop x,y,sgn,dop
        case "R"
            call rook x,y,sgn,dop
        case "Q"
            call queen x,y,sgn,dop
        case "K"
            call king x,y,sgn,dop
    end select
end sub

sub pawn x,y,sgn,dop
    'capture right?
    if x+1<=7 and y-dop >=0 and y-dop <=7 then
        if bsign(x+1,y-dop)=0-sgn then
            Move=Move+1
            movex(Move,Level)=x+1
            movey(Move,Level)=y-dop
        end if
    end if
    'capture left?
    if x-1>=0 and y-dop >=0 and y-dop <=7 then
        if bsign(x-1,y-dop)=0-sgn then
            Move=Move+1
            movex(Move,Level)=x-1
            movey(Move,Level)=y-dop
        end if
    end if
    'one forward?
    if y-dop >=0 and y-dop<=7 then
        if bsign(x,y-dop)=0 then
            Move=Move+1
            movex(Move,Level)=x
            movey(Move,Level)=y-dop
            'two forward?
            if (y=1 and dop=-1) or (y=6 and dop=1) then
                if bsign(x,y-dop*2)=0 then
                    Move=Move+1
                    movex(Move,Level)=x
                    movey(Move,Level)=y-dop*2
                end if
            end if
        end if
    end if
end sub

sub knight x,y,sgn,dop
    x1=x-1
    y1=y-2
    gosub [addmove]
    x1=x-2
    y1=y-1
    gosub [addmove]
    x1=x+1
    y1=y-2
    gosub [addmove]
    x1=x+2
    y1=y-1
    gosub [addmove]
    x1=x-1
    y1=y+2
    gosub [addmove]
    x1=x-2
    y1=y+1
    gosub [addmove]
    x1=x+1
    y1=y+2
    gosub [addmove]
    x1=x+2
    y1=y+1
    gosub [addmove]
    exit sub

    [addmove]
    if x1<0 or x1>7 or y1<0 or y1>7 then return
    if sgn <> bsign(x1,y1) then
        Move=Move+1
        movex(Move,Level)=x1
        movey(Move,Level)=y1
    end if
    return
end sub

sub bishop x,y,sgn,dop
    for dxy=1 to 7
        x1=x-dxy
        y1=y+dxy
        'off the board?
        if x1<0 or x1>7 or y1<0 or y1>7 then exit for
        gosub [addmove]
        'found a piece to capture or own man then stop
        if bsign(x1,y1)<>0 then exit for
    next
    for dxy=1 to 7
        x1=x+dxy
        y1=y+dxy
        if x1<0 or x1>7 or y1<0 or y1>7 then exit for
        gosub [addmove]
        if bsign(x1,y1)<>0 then exit for
    next
    for dxy=1 to 7
        x1=x-dxy
        y1=y-dxy
        if x1<0 or x1>7 or y1<0 or y1>7 then exit for
        gosub [addmove]
        if bsign(x1,y1)<>0 then exit for
    next
    for dxy=1 to 7
        x1=x+dxy
        y1=y-dxy
        if x1<0 or x1>7 or y1<0 or y1>7 then exit for
        gosub [addmove]
        if bsign(x1,y1)<>0 then exit for
    next
    exit sub

    [addmove]
    if bsign(x1,y1)<>sgn then
        Move=Move+1
        movex(Move,Level)=x1
        movey(Move,Level)=y1
    end if
    return
end sub

sub rook x,y,sgn,dop
    for x1=x-1 to 0 step-1
        if bsign(x1,y)<>sgn then
            Move=Move+1
            movex(Move,Level)=x1
            movey(Move,Level)=y
        end if
        if bsign(x1,y)<>0 then exit for
    next
    for x1=x+1 to 7
        if bsign(x1,y)<>sgn then
            Move=Move+1
            movex(Move,Level)=x1
            movey(Move,Level)=y
        end if
        if bsign(x1,y)<>0 then exit for
    next
    for y1=y-1 to 0 step-1
        if bsign(x,y1)<>sgn then
            Move=Move+1
            movex(Move,Level)=x
            movey(Move,Level)=y1
        end if
        if bsign(x,y1)<>0 then exit for
    next
    for y1=y+1 to 7
        if bsign(x,y1)<>sgn then
            Move=Move+1
            movex(Move,Level)=x
            movey(Move,Level)=y1
        end if
        if bsign(x,y1)<>0 then exit for
    next
end sub

sub queen x,y,sgn,dop
    call bishop x,y,sgn,dop
    call rook x,y,sgn,dop
end sub

sub king x,y,sgn,dop
    for dy=-1 to 1
        if y+dy<0 or y+dy>7 then [bypass2]
        for dx=-1 to 1
            if x+dx<0 or x+dx>7 then goto [bypass1]
            if bsign(x+dx,y+dy)<>sgn then
                Move=Move+1
                movex(Move,Level)=x+dx
                movey(Move,Level)=y+dy
            end if
            [bypass1]
        next
        [bypass2]
    next
end sub


sub makemove x,y,x1,y1

    'fill square taken
    board$(x1,y1)=board$(x,y)

    'erase square vacated
    board$(x,y)="      0"

    'promote pawn if it reaches board edge
    if (y1=0 or y1=7) and mid$(board$(x1,y1),2,1)="P" and Level=0 then

        'switch off original sprite
        #w.g "spritevisible ";left$(board$(x1,y1),3);" off"
        Spritetaken$=Spritetaken$+left$(board$(x1,y1),3)+","
        'add new queen sprite
        'wp1 wp8 become wq2-wq9
        board$(x1,y1)=mid$(board$(x1,y1),1,1)+"Q"+mid$(board$(x1,y1),3,1)+" 900"
        if left$(board$(x1,y1),1)="W" then
            #w.g "addsprite ";left$(board$(x1,y1),3);" WQ WQ1"
            #w.g "spritexy ";left$(board$(x1,y1),3);" ";x1;" ";y1
            Spriteadded$=Spriteadded$+left$(board$(x1,y1),3)+" WQ WQ1,"
            call text "New white Queen"
        else
            #w.g "addsprite ";left$(board$(x1,y1),3);" BQ BQ1"
            #w.g "spritexy ";left$(board$(x1,y1),3);" ";x1;" ";y1
            Spriteadded$=Spriteadded$+left$(board$(x1,y1),3)+" BQ BQ1,"
            call text "New black Queen"
        end if
    end if
end sub

sub showboard
    for y= 7 to 0 step -1
        for x= 0 to 7
        s$=left$(board$(x,y),3)
            if s$<>"   " then
                #w.g "spritetoback ";s$
                #w.g "spritescale ";s$;" ";bspritez(x,y)
                #w.g "spritexy ";s$;" ";bspritex(x,y);" ";bspritey(x,y)
            end if
        next
    next
    #w.g "spritetoback m"
    #w.g "spritetoback t"
    #w.g "drawsprites"
end sub

sub fillboard

    'find how much whitespace the windows scheme is taking
    'so that our controls fit neatly in the window,
    'Anatoly's tip
    WindowWidth = 200
    WindowHeight = 200
    open "Ajusting..." for graphics_nf_nsb as #1
    #1, "home ; down ; posxy w h"
    w=200-2*w : h = 200-2*h
    close #1
    WindowWidth  = 1000+w
    WindowHeight = 600+h
    UpperLeftX   = (DisplayWidth-WindowWidth)/2
    UpperLeftY   = (DisplayHeight-WindowHeight)/2
    graphicbox #w.g, 0,0,802,602
    graphicbox #w.tb, 802,0,200,602

    open "Liberty BASIC Chess" for window_nf as #w
    #w "trapclose quit"
    #w.g "down"
    #w.tb "down ;backcolor lightgray; color black"

    loadbmp "tb","text.bmp"
    #w.tb "drawbmp tb 0 0 ; flush bak"




    loadbmp "white", "white.bmp"
    loadbmp "black", "black.bmp"
    loadbmp "WP","wp.bmp"
    loadbmp "BP","bp.bmp"
    loadbmp "WR","wr.bmp"
    loadbmp "BR","br.bmp"
    loadbmp "WN","wn.bmp"
    loadbmp "BN","bn.bmp"
    loadbmp "WB","wb.bmp"
    loadbmp "BB","bb.bmp"
    loadbmp "WQ","wq.bmp"
    loadbmp "BQ","bq.bmp"
    loadbmp "WK","wk.bmp"
    loadbmp "BK","bk.bmp"
    loadbmp "WP1","wp1.bmp"
    loadbmp "BP1","bp1.bmp"
    loadbmp "WR1","wr1.bmp"
    loadbmp "BR1","br1.bmp"
    loadbmp "WN1","wn1.bmp"
    loadbmp "BN1","bn1.bmp"
    loadbmp "WB1","wb1.bmp"
    loadbmp "BB1","bb1.bmp"
    loadbmp "WQ1","wq1.bmp"
    loadbmp "BQ1","bq1.bmp"
    loadbmp "WK1","wk1.bmp"
    loadbmp "BK1","bk1.bmp"
    loadbmp "m","mover.bmp"
    loadbmp "t","target.bmp"

    loadbmp "c0","num0.bmp"
    loadbmp "c1","num1.bmp"
    loadbmp "c2","num2.bmp"
    loadbmp "c3","num3.bmp"
    loadbmp "c4","num4.bmp"
    loadbmp "c5","num5.bmp"
    loadbmp "c6","num6.bmp"
    loadbmp "c7","num7.bmp"
    loadbmp "c8","num8.bmp"
    loadbmp "c9","num9.bmp"

    'load the buttons
    loadbmp "pa","pause.bmp"
    loadbmp "po","pauseon.bmp"
    loadbmp "lo","load.bmp"
    loadbmp "sa","save.bmp"
    loadbmp "re","resign.bmp"
    loadbmp "cl","castlel.bmp"
    loadbmp "cr","castler.bmp"
    loadbmp "ud","undo.bmp"
    loadbmp "rv","reverse.bmp"

    #w.g "addsprite pa pa ; spritexy pa 5 5 ; spritevisible pa off"
    #w.g "addsprite po po ; spritexy po 5 5 ; spritevisible po off"
    #w.g "addsprite lo lo ; spritexy lo 5 35 ; spritevisible lo off"
    #w.g "addsprite sa sa ; spritexy sa 5 65 ; spritevisible sa off"
    #w.g "addsprite ud ud ; spritexy ud 5 95 ; spritevisible ud off"
    #w.g "addsprite cl cl ; spritexy cl 5 125 ; spritevisible cl off"
    #w.g "addsprite cr cr ; spritexy cr 5 155; spritevisible cr off"
    #w.g "addsprite re re ; spritexy re 5 185 ; spritevisible re off"
    #w.g "addsprite rv rv ; spritexy rv 5 215 ; spritevisible rv off"



    'load the clock
    xx=220
    yy=50
    for x=1 to 8
        #w.g "addsprite clock";str$(x);" c0 c1 c2 c3 c4 c5 c6 c7 c8 c9"
        #w.g "spritexy clock";str$(x);" ";xx;" ";yy
        xx=xx+35
        if x=4 then xx=xx+52
        if x=2 or x=6 then xx=xx+10
    next

    restore [data]
    for y = 0 TO 7
        for x = 0 TO 7
            read v,n$
            if n$="" then n$="   "
            board$(x,y)=n$+right$("    "+str$(v),4)
        next
    next

    'store sprite drawing positions
    for y = 0 to 7
        read zz
        read yy
        for x = 0 to 7
            read xx
            bspritez(x,y)=zz
            bspritey(x,y)=yy
            bspritex(x,y)=xx
        next
    next

    'store mouse click positions
    for y = 0 to 8
        read yy
        for x = 0 to 8
            read xx
            bpointrx(x,y)=xx
            bpointry(x,y)=yy
        next
    next

    'store square names
    for y = 0 to 7
        for x = 0 to 7
        bsquare$(x,y)=chr$(65+x)+str$(8-y)
        next
    next

    'load pointer sprites
    #w.g "addsprite m m"
    #w.g "spritevisible m off"
    #w.g "addsprite t t"
    #w.g "spritevisible t off"

    'load player sprites normal and highlighted
    for y=0 to 1
        for x = 0 to 7
            spritesname$=left$(board$(x,y),3)
            #w.g "addsprite ";spritesname$;" ";left$(spritesname$,2);" ";left$(spritesname$,2);"1"
            if instr("BB2 BN2 WB2 WN2",spritesname$,1) then #w.g "spriteorient ";spritesname$;" mirror"
            #w.g "spritescale ";spritesname$;" ";bspritez(x,y)
            #w.g "spritexy ";spritesname$;" ";bspritex(x,y);" ";bspritey(x,y)
        next
    next
    for y=6 to 7
        for x = 0 to 7
            spritesname$=left$(board$(x,y),3)
            #w.g "addsprite ";spritesname$;" ";left$(spritesname$,2);" ";left$(spritesname$,2);"1"
            if instr("BB2 BN2 WB2 WN2",spritesname$,1) then #w.g "spriteorient ";spritesname$;" mirror"
            #w.g "spritescale ";spritesname$;" ";bspritez(x,y)
            #w.g "spritexy ";spritesname$;" ";bspritex(x,y);" ";bspritey(x,y)
        next
    next

    if AI=White then #w.g "background black" else #w.g "background white"
    #w.g "drawsprites"
    call savegame "undo.und"
    call savegame "NewWhite.gam"
    call reversegame
    call savegame "NewBlack.gam"
    call reversegame

    [data]
    DATA 500,"BR1",270,"BN1",300,"BB1",900,"BQ1",7500,"BK1",300,"BB2",270,"BN2",500,"BR2"
    DATA 100,"BP1",100,"BP2",100,"BP3",100,"BP4",100,"BP5",100,"BP6",100,"BP7",100,"BP8"
    DATA 0,"",0,"",0,"",0,"",0,"",0,"",0,"",0,""
    DATA 0,"",0,"",0,"",0,"",0,"",0,"",0,"",0,""
    DATA 0,"",0,"",0,"",0,"",0,"",0,"",0,"",0,""
    DATA 0,"",0,"",0,"",0,"",0,"",0,"",0,"",0,""
    DATA 100,"WP1",100,"WP2",100,"WP3",100,"WP4",100,"WP5",100,"WP6",100,"WP7",100,"WP8"
    DATA 500,"WR1",270,"WN1",300,"WB1",900,"WQ1",5000,"WK1",300,"WB2",270,"WN2",500,"WR2"

    data 100,128,187,238,290,343,395,449,501,555
    data 105,156,177,231,286,340,395,451,507,560
    data 110,190,168,225,281,338,395,454,510,568
    data 115,225,157,215,275,335,395,455,516,575
    data 120,265,146,208,269,332,395,458,520,584
    data 125,310,133,197,265,328,395,461,527,593
    data 130,350,120,188,257,326,395,465,534,604
    data 135,410,104,176,249,321,395,467,541,614

    data 170,187,238,290,343,395,449,501,555,606
    data 204,177,231,286,340,395,451,507,560,614
    data 237,168,225,281,338,395,454,510,568,623
    data 273,157,215,275,335,395,455,516,575,636
    data 312,146,208,269,332,395,458,520,584,645
    data 355,133,197,265,328,395,461,527,593,660
    data 403,120,188,257,326,395,465,534,604,671
    data 454,104,176,249,321,395,467,541,614,693
    data 516,104,176,249,321,395,467,541,614,693

end sub



'this function checks all squares to see if
'any opposition piece has the king in check
function incheck(sgn)
    for x=0 to 7
        for y=0 to 7
            if bsign(x,y)=0-sgn then
                call movelist x,y,0-sgn
                for m=0 to Move
                    if mid$(board$(movex(m,Level),movey(m,Level)),2,1)="K" then
                        incheck = 1
                        exit function
                    end if
                next
            end if
        next
   next
end function

'this function checks all squares for players to move then recursively test plays
'it plays its own move then plays the opponents best move, recursively over x moves.
'So getting the potential net worth of each moveable player on the board. The highest
'scored determines the computers next move.
'It is a classic mini max evaluation shortened to its negamax form with pruning
'ie it does not waste time on lower value plays.

function evaluatecomputermove(sgn,prune)
    Level=Level+1
    bestscore=10000*sgn
    for y= 7 to 0 step -1
        if date$("days")*Secday+time$("seconds")>Timecounter then Timecounter=date$("days")*Secday+time$("seconds"):call clock
        for x= 7 to 0 step -1
            if bsign(x,y)=sgn then
                call movelist x,y,sgn
                for m=0 to Move
                    x1=movex(m,Level)
                    y1=movey(m,Level)
                    oldscore=Score
                    'store mover and target data so that it may be restored
                    moversprite$=board$(x,y)
                    targetsprite$=board$(x1,y1)
                    targetvalue=val(mid$(board$(x1,y1),4,4))*bsign(x1,y1)
                    call makemove x,y,x1,y1
                    if Level<Maxlevel then Score=Score+evaluatecomputermove(0-sgn,bestscore - targetvalue + sgn*(8-abs(4-x1)-abs(4-y1)))
                    'we unwind the recursion by coming back here until we finaly return to the main program flow
                    'work out the score adding a small amount to favour forwards and central play
                    Score=Score+targetvalue-sgn*(8-abs(4-x1)-abs(4-y1))
                    'if it results in a better score than previously then store it as best
                    if (sgn<0 and Score > bestscore) or (sgn>0 and Score < bestscore) then
                        bestx(Level)=x
                        besty(Level)=y
                        bestx1(Level)=x1
                        besty1(Level)=y1
                        bestscore = Score
                        'if it isn't as good as as a previous pieces move then cut the search short
                        if (sgn<0 and bestscore>=prune) or (sgn>0 and bestscore<=prune) then
                            'reset play
                            board$(x,y)=moversprite$
                            board$(x1,y1)=targetsprite$
                            Score=oldscore
                            Level=Level-1
                            evaluatecomputermove=bestscore
                            exit function
                        end if
                    end if
                    'reset play
                    board$(x,y)=moversprite$
                    board$(x1,y1)=targetsprite$
                    Score=oldscore
                next
            end if
        next
    next
    Level=Level-1
    evaluatecomputermove=bestscore
end function


function showtaken(x,y,sgn)
    showtaken=0
    showtaken$=mid$(board$(x,y),4,4)
    if showtaken$<>"   0" then
        if sgn<0 then m$= "Black takes "
        if sgn>0 then m$= "White takes "
        if showtaken$=" 100" then m$=m$+ "Pawn"
        if showtaken$=" 270" then m$=m$+ "Knight"
        if showtaken$=" 300" then m$=m$+ "Bishop"
        if showtaken$=" 500" then m$=m$+ "Rook"
        if showtaken$=" 900" then m$=m$+ "Queen"
        if showtaken$="5000" then m$=m$+ "King"
        if showtaken$="7500" then m$=m$+ "King"
        call text m$
        showtaken=1
    end if
end function

function bsign(x,y)
    bsign=0
    if left$(board$(x,y),1)="B" then bsign=-1
    if left$(board$(x,y),1)="W" then bsign=1
end function

sub trackit h$,x,y
    if Paused<>1 and x>5 and x<105 and y>5 and y<30 then #w.g "spritevisible pa on" else #w.g "spritevisible pa off"
    if x>5 and x<105 and y>35 and y<60 then #w.g "spritevisible lo on" else #w.g "spritevisible lo off"
    if x>5 and x<105 and y>65 and y<90 then #w.g "spritevisible sa on" else #w.g "spritevisible sa off"
    if x>5 and x<105 and y>95 and y<120 then #w.g "spritevisible ud on" else #w.g "spritevisible ud off"
    if x>5 and x<105 and y>125 and y<150 then #w.g "spritevisible cl on" else #w.g "spritevisible cl off"
    if x>5 and x<105 and y>155 and y<180 then #w.g "spritevisible cr on" else #w.g "spritevisible cr off"
    if x>5 and x<105 and y>185 and y<210 then #w.g "spritevisible re on" else #w.g "spritevisible re off"
    if x>5 and x<105 and y>215 and y<240 then #w.g "spritevisible rv on" else #w.g "spritevisible rv off"

    #w.g "drawsprites"
end sub

sub text m$
    for n=30 to 2 step -1
        text$(n)=text$(n-1)
    next
    text$(1)=m$
    #w.tb "discard ; redraw bak"
    #w.tb "place 25 80"
    for n= 1 to 30
        #w.tb "\";text$(n)
    next
end sub

sub clock
    if Status=1 then Whitetime=Whitetime+1
    if Status=2 then Blacktime=Blacktime+1
    wm=int(Whitetime/60)
    ws=Whitetime-60*wm
    wt$=right$("00"+str$(wm),2)+right$("00"+str$(ws),2)
    bm=int(Blacktime/60)
    bs=Blacktime-60*bm
    bt$=right$("00"+str$(bm),2)+right$("00"+str$(bs),2)

    for n= 1 to 4
        #w.g "spriteimage clock";str$(n);" c";mid$(wt$,n,1)
        #w.g "spriteimage clock";str$(n+4);" c";mid$(bt$,n,1)
    next
    #w.g "drawsprites"
    'if wm>14 or bm>14 then
    '    call text "Time limit!"
    '    call text "Game ends"
    '    wait
    'end if

end sub

sub loadgame f$
    'not all loads are at start of game so for mid game load
    'make all sprites visible
    sl$="BR1,BN1,BB1,BQ1,BK1,BB2,BN2,BR2,BP1,BP2,BP3,BP4,BP5,BP6,BP7,BP8,WP1,WP2,WP3,WP4,WP5,WP6,WP7,WP8,WR1,WN1,WB1,WQ1,WK1,WB2,WN2,WR2"
     n=1
    s$=word$(sl$,n,",")
    while s$<>""
        #w.g "spritevisible ";s$;" on"
        n=n+1
        s$=word$(sl$,n,",")
    wend
    'now retrieve saved board
    open f$ for input as #1
    line input #1, AI
    if AI=White then #w.g "background black" else #w.g "background white"
    line input #1, Whitetime
    line input #1, Blacktime
    for y=0 to 7
        for x=0 to 7
            line input #1,board$(x,y)
            line input #1,bsquare$(x,y)
        next
    next
    line input #1,Spriteadded$
    line input #1,Spritetaken$
    line input #1,old(1)
    line input #1,old(2)
    line input #1,old(3)
    line input #1,old(4)
    close #1
    'add in any new queen sprites and make them visible
    n=1
    a$=word$(Spriteadded$,n,",")
    while a$<>""
        #w.g "addsprite ";a$
        #w.g "spritevisible ";a$;" on"
        n=n+1
        a$=word$(Spriteadded$,n,",")
    wend
    'now make all taken sprites invisible
    n=1
    a$=word$(Spritetaken$,n,",")
    while a$<>""
        #w.g "spritevisible ";a$;" off"
        n=n+1
        a$=word$(Spritetaken$,n,",")
    wend
    'save for undo
    call savegame "undo1.und"
end sub

sub savegame f$
    open f$ for output as #1
    #1, AI
    #1, Whitetime
    #1, Blacktime
    for y=0 to 7
        for x=0 to 7
            #1,board$(x,y)
            #1,bsquare$(x,y)
        next
    next
    #1,Spriteadded$
    #1,Spritetaken$
    #1,old(1)
    #1,old(2)
    #1,old(3)
    #1,old(4)
    close #1
end sub

sub reversegame
    AI=0-AI
    if AI=White then #w.g "background black" else #w.g "background white"
    for y=0 to 7
        for x=0 to 3
            sp$=board$(x,y)
            bs$=bsquare$(x,y)

            board$(x,y)=board$(7-x,7-y)
            bsquare$(x,y)=bsquare$(7-x,7-y)

            board$(7-x,7-y)=sp$
            bsquare$(7-x,7-y)=bs$
        next
    next
    call showboard
end sub



sub quit h$
    close #w
    end
end sub


